<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateSuppliersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('st_suppliers', function (Blueprint $table) {
            $table->string('supplier_id',)->unique();
            $table->string('supplier_name', 100);
            $table->string('address');
            $table->string('web_address');
            $table->string('country_id');
            $table->string('district_id');
            $table->string('town_id');
            $table->string('gmap', 250);
            $table->string('supplier_type_id');
            $table->string('account_group_id');
            $table->string('tax1_no');
            $table->string('tax2_no');
            $table->string('alert_credit_limit');
            $table->string('alert_credit_period');
            $table->string('hold_credit_limit');
            $table->string('hold_credit_period');
            $table->string('status_id');
            $table->string('notes');
            $table->string('bank_id');
            $table->string('bank_branch_id');
            
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('suppliers');
    }
}
